using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 工单修改日志
    /// </summary>
    public partial class T_Wo_WorkOrder_Logs
    {
        public T_Wo_WorkOrder_Logs()
        { }
        #region  BasicMethod

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(long Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Wo_WorkOrder_Logs");
            strSql.Append(" where Id=@Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@Id", SqlDbType.BigInt)
            };
            parameters[0].Value = Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public long Add(Model.T_Wo_WorkOrder_Logs model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Wo_WorkOrder_Logs(");
            strSql.Append("WorkOrderID,BeforeContent,UpdateContent,UserCode,AddTime,IsDelete,DelUserCode,TypeId,AreaId,ProId,StageId,Remark)");
            strSql.Append(" values (");
            strSql.Append("@WorkOrderID,@BeforeContent,@UpdateContent,@UserCode,@AddTime,@IsDelete,@DelUserCode,@TypeId,@AreaId,@ProId,@StageId,@Remark)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@WorkOrderID", SqlDbType.VarChar,50),
                    new SqlParameter("@BeforeContent", SqlDbType.NVarChar,1000),
                    new SqlParameter("@UpdateContent", SqlDbType.NVarChar,1000),
                    new SqlParameter("@UserCode", SqlDbType.VarChar,50),
                    new SqlParameter("@AddTime", SqlDbType.DateTime),
                    new SqlParameter("@IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@DelUserCode", SqlDbType.VarChar,50),
                    new SqlParameter("@TypeId", SqlDbType.Int,4),
                    new SqlParameter("@AreaId", SqlDbType.Int,4),
                    new SqlParameter("@ProId", SqlDbType.Int,4),
                    new SqlParameter("@StageId", SqlDbType.Int,4),
                    new SqlParameter("@Remark", SqlDbType.VarChar,100)};
            parameters[0].Value = model.WorkOrderID;
            parameters[1].Value = model.BeforeContent;
            parameters[2].Value = model.UpdateContent;
            parameters[3].Value = model.UserCode;
            parameters[4].Value = model.AddTime;
            parameters[5].Value = model.IsDelete;
            parameters[6].Value = model.DelUserCode;
            parameters[7].Value = model.TypeId;
            parameters[8].Value = model.AreaId;
            parameters[9].Value = model.ProId;
            parameters[10].Value = model.StageId;
            parameters[11].Value = model.Remark;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt64(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Wo_WorkOrder_Logs model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Wo_WorkOrder_Logs set ");
            strSql.Append("WorkOrderID=@WorkOrderID,");
            strSql.Append("BeforeContent=@BeforeContent,");
            strSql.Append("UpdateContent=@UpdateContent,");
            strSql.Append("UserCode=@UserCode,");
            strSql.Append("AddTime=@AddTime,");
            strSql.Append("IsDelete=@IsDelete,");
            strSql.Append("DelUserCode=@DelUserCode,");
            strSql.Append("TypeId=@TypeId,");
            strSql.Append("AreaId=@AreaId,");
            strSql.Append("ProId=@ProId,");
            strSql.Append("StageId=@StageId,");
            strSql.Append("Remark=@Remark");
            strSql.Append(" where Id=@Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@WorkOrderID", SqlDbType.VarChar,50),
                    new SqlParameter("@BeforeContent", SqlDbType.NVarChar,1000),
                    new SqlParameter("@UpdateContent", SqlDbType.NVarChar,1000),
                    new SqlParameter("@UserCode", SqlDbType.VarChar,50),
                    new SqlParameter("@AddTime", SqlDbType.DateTime),
                    new SqlParameter("@IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@DelUserCode", SqlDbType.VarChar,50),
                    new SqlParameter("@TypeId", SqlDbType.Int,4),
                    new SqlParameter("@AreaId", SqlDbType.Int,4),
                    new SqlParameter("@ProId", SqlDbType.Int,4),
                    new SqlParameter("@StageId", SqlDbType.Int,4),
                    new SqlParameter("@Remark", SqlDbType.VarChar,100),
                    new SqlParameter("@Id", SqlDbType.BigInt,8)};
            parameters[0].Value = model.WorkOrderID;
            parameters[1].Value = model.BeforeContent;
            parameters[2].Value = model.UpdateContent;
            parameters[3].Value = model.UserCode;
            parameters[4].Value = model.AddTime;
            parameters[5].Value = model.IsDelete;
            parameters[6].Value = model.DelUserCode;
            parameters[7].Value = model.TypeId;
            parameters[8].Value = model.AreaId;
            parameters[9].Value = model.ProId;
            parameters[10].Value = model.StageId;
            parameters[11].Value = model.Remark;
            parameters[12].Value = model.Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(long Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Wo_WorkOrder_Logs ");
            strSql.Append(" where Id=@Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@Id", SqlDbType.BigInt)
            };
            parameters[0].Value = Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Wo_WorkOrder_Logs ");
            strSql.Append(" where Id in (" + Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Wo_WorkOrder_Logs GetModel(long Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 Id,WorkOrderID,BeforeContent,UpdateContent,UserCode,AddTime,IsDelete,DelUserCode,TypeId,AreaId,ProId,StageId,Remark from T_Wo_WorkOrder_Logs ");
            strSql.Append(" where Id=@Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@Id", SqlDbType.BigInt)
            };
            parameters[0].Value = Id;

            Model.T_Wo_WorkOrder_Logs model = new Model.T_Wo_WorkOrder_Logs();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Wo_WorkOrder_Logs DataRowToModel(DataRow row)
        {
            Model.T_Wo_WorkOrder_Logs model = new Model.T_Wo_WorkOrder_Logs();
            if (row != null)
            {
                if (row["Id"] != null && row["Id"].ToString() != "")
                {
                    model.Id = long.Parse(row["Id"].ToString());
                }
                if (row["WorkOrderID"] != null)
                {
                    model.WorkOrderID = row["WorkOrderID"].ToString();
                }
                if (row["BeforeContent"] != null)
                {
                    model.BeforeContent = row["BeforeContent"].ToString();
                }
                if (row["UpdateContent"] != null)
                {
                    model.UpdateContent = row["UpdateContent"].ToString();
                }
                if (row["UserCode"] != null)
                {
                    model.UserCode = row["UserCode"].ToString();
                }
                if (row["AddTime"] != null && row["AddTime"].ToString() != "")
                {
                    model.AddTime = DateTime.Parse(row["AddTime"].ToString());
                }
                if (row["IsDelete"] != null && row["IsDelete"].ToString() != "")
                {
                    model.IsDelete = int.Parse(row["IsDelete"].ToString());
                }
                if (row["DelUserCode"] != null)
                {
                    model.DelUserCode = row["DelUserCode"].ToString();
                }
                if (row["TypeId"] != null && row["TypeId"].ToString() != "")
                {
                    model.TypeId = int.Parse(row["TypeId"].ToString());
                }
                if (row["AreaId"] != null && row["AreaId"].ToString() != "")
                {
                    model.AreaId = int.Parse(row["AreaId"].ToString());
                }
                if (row["ProId"] != null && row["ProId"].ToString() != "")
                {
                    model.ProId = int.Parse(row["ProId"].ToString());
                }
                if (row["StageId"] != null && row["StageId"].ToString() != "")
                {
                    model.StageId = int.Parse(row["StageId"].ToString());
                }
                if (row["Remark"] != null)
                {
                    model.Remark = row["Remark"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select Id,WorkOrderID,BeforeContent,UpdateContent,UserCode,AddTime,IsDelete,DelUserCode,TypeId,AreaId,ProId,StageId,Remark ");
            strSql.Append(" FROM T_Wo_WorkOrder_Logs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" Id,WorkOrderID,BeforeContent,UpdateContent,UserCode,AddTime,IsDelete,DelUserCode,TypeId,AreaId,ProId,StageId,Remark ");
            strSql.Append(" FROM T_Wo_WorkOrder_Logs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Wo_WorkOrder_Logs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Wo_WorkOrder_Logs T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Wo_WorkOrder_Logs";
			parameters[1].Value = "Id";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
